Qore::TransformOutputStream Class Reference

This class implements the OutputStream interface for writing bytes to another OutputStream while applying a transformation. More...

Inheritance diagram for Qore::TransformOutputStream:
[legend]

## Public Member Functions

nothing | close ()
| Flushes any buffered (unwritten) bytes, closes the output stream and releases all resources. More...
| constructor (Qore::OutputStream os, Qore::Transform t)
| Creates the TransformOutputStream. More...
nothing | write (binary data)
| Writes bytes to the output stream. More...
Public Member Functions inherited from Qore::OutputStream
| constructor ()
| Constructor. More...
Public Member Functions inherited from Qore::StreamBase
| constructor ()
| Throws an exception if called directly; this class can only be instantiated by builtin subclasses. More...
int | getThreadId ()
| Get the currently assigned thread id or -1 if not assigned to any thread.
nothing | reassignThread ()
| Reassigns current thread as thread used for stream manipulation. More...
nothing | unassignThread ()
| Unassigns current thread as thread used for stream manipulation. More...

## Detailed Description

This class implements the OutputStream interface for writing bytes to another OutputStream while applying a transformation.

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown, unless the stream is handed off to another thread using the StreamBase::unassignThread() method in the thread that currently owns the stream, and the StreamBase::reassignThread() method in the new thread.

See also
  StreamWriter for a class that can be used to write various kinds of data to an OutputStream

Since
  Qore 0.8.13

## Member Function Documentation

## close()

nothing Qore::TransformOutputStream::close | ( |  | ) |

virtual

Flushes any buffered (unwritten) bytes, closes the output stream and releases all resources.

Any methods called on a closed output stream will throw an exception.

Exceptions

  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::OutputStream.

## constructor()

Qore::TransformOutputStream::constructor | ( | Qore::OutputStream | os,
|  | Qore::Transform | t
| ) |  |

Creates the TransformOutputStream.

Parameters

  os | the underlying OutputStream where the transformed data will be written to
  t | the transformation to apply

## write()

nothing Qore::TransformOutputStream::write | ( | binary | data | ) |

virtual

Writes bytes to the output stream.

Parameters

  data | the data to write

Exceptions

  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::OutputStream.